/* check for size of types (usefull for precompiler-conditions)
 * - 8*sizeof(VAR) and used_bits(VAR) can differ!
 *   ex: cray T3E sizeof(short)==8
 */
#include <stdio.h>
#include <stdlib.h>
#ifdef CONFIG_MPI
#include <mpi.h>
#endif

int main(int argn, char *argv[]){
 char c1;short s1;int i,i1;long l1=1;
#ifdef CONFIG_MPI
 MPI_Init(&argn,&argv);
#endif
 /* some systems are bi-endian an can be switched between little/big-endian */
 /* bi-endian (switchable): arm, (some) mips, ... */
 if(*((char *)&l1)==1)
 printf("/* LOW-HIGH byte order, Little-Endian-First Byte Order (x86) */\n"
        "#define LHsystem\n"); /* x86, alpha */
 else
 printf("/* HIGH-LOW byte order, Big-Endian-First Byte Order */\n"
        "#define HLsystem\n"); /* Motorola 68k, PowerPC, Sparc, MIPS */
 for(i=0,c1=1;c1!=0;i++,c1<<=8);
 printf("#define B_char    %d\n"  ,i);
 printf("#define S_char    %d\n"  ,(int)sizeof(char));
 for(i=0,s1=1;s1!=0;i++,s1<<=8);
 printf("#define B_short   %d\n"  ,i);
 printf("#define S_short   %d\n"  ,(int)sizeof(short int));
 for(i=0,i1=1;i1!=0;i++,i1<<=8);
 printf("#define B_int     %d\n"  ,i);
 printf("#define S_int     %d\n"  ,(int)sizeof(int));
 for(i=0,l1=1;l1!=0;i++,l1<<=8);
 printf("#define B_long    %d\n"  ,i);
 printf("#define S_long    %d\n\n",(int)sizeof(long));
// linux.math.h: defined( __NO_LONG_DOUBLE_MATH )
// linux.bits/wordsize.h: __WORDSIZE 64 or 32 
#ifdef CONFIG_LLONG	/* set by make -DTEST_LLONG */
 printf("#define S_llong    %d\n\n",(int)sizeof(long long));
#endif	/* S_llong only defined if compiler knows type long long */
 printf("#define S_float   %d\n"  ,(int)sizeof(float));
 printf("#define S_double  %d\n"  ,(int)sizeof(double));
 printf("#define S_ldouble %d\n"  ,(int)sizeof(long double));
 printf("\n");	/* cray-cc does like a final \n ;) */
#ifdef CONFIG_MPI
 MPI_Finalize();  
#endif
 return 0;
}

/* dummerweise ist auf cray-cc sizeof(short)==8 aber
   fordere 6 bytes werden nur fuer signum benutzt!
   << oder >> wirken nicht
*/
